#!/usr/bin/php -Cq
<?php
/*
INSTALL:

1. Create some folders like:
   mkdir /var/spool/msnbot
   mkdir /var/spool/msnbot/log
   mkdir /var/spool/msnbot/spool

2. Change the attribute for spool folder:
   chmod 777 /var/spool/msnbot/spool
   chmod o+t /var/spool/msnbot/spool

3. Put msnbot.php and msn.class.php to /var/spool/msnbot/, and make msnbot.php executable:
   chmod +x /var/spool/msnbot/msnbot.php

4. Use msnbot.sh as your startup script to execute msnbot after system boot.

5. Change processMsg function in msnbot.php to do whatever you want.

6. If you need to send message to someone, just create a file under /var/spool/msnbot/spool, the filename like '*.msn',
   and the format like test.msn, first line is TO: email1,email2, and the other lines is the message.
   After create the file, just change the attribute to 0666, then msnbot will try to send it.

*/

error_reporting(0);

$pid = pcntl_fork();
if ($pid) exit;

$msn_acct = 'YOUR_MSN_ACCOUNT';
$msn_password = 'YOUR_MSN_PASSWORD';
$msn_alias = 'YOUR_MSN_ALIAS';

include_once('msn.class.php');

$aContact = false;
$msn = new MSN('', dirname($_SERVER['argv'][0]).'/log/debug.log');
if ($msn->protocol == 'MSNP15') {
    // we can't get contact list for MSNP15 now, so try to get it from MSNP9
    $msnp9 = new MSN('MSNP9', dirname($_SERVER['argv'][0]).'/log/debug.log');
    $aContact = $msnp9->getContactList($msn_acct, $msn_password);
    unset($msnp9);
}

/*

function doLoop($user,
                $password,
                $alias = '',
                $contact_list = false,
                $my_function = false,
                $use_ping = false,
                $retry_wait = 30);

$user: the MSN account
$password: password of the MSN account
$alias: the MSN alias, if empty, the program will use $user
$contact_list: a contact list array, only need this for MSNP15, because I can't get the list from MSNP15 now... :-(
               for MSNP9, everyone in your list will see your stauts automatic,
               but in MSNP15, we need a list to send ADL command to let them know we're online, so they can send message to us.
$my_function: your message process function, if empty, msnbot will ignore any message.
$use_ping: if true, msnbot will send PNG to server (0-50 seconds) to keep alive, but... even without this, we're still online.
$retry_wait: if we lost connection, how long we should wait before we try again.


*/
$msn->doLoop($msn_acct, $msn_password, $msn_alias, $aContact, 'processMsg');

exit;

// your function to process message from someone
function processMsg($from, $msg)
{
    return "message from $from:\r\n$msg";
}

?>

